# coding: utf-8
# frozen_string_literal: true

lib = File.expand_path('../lib', __FILE__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'dry/plugins/version'

Gem::Specification.new do |spec|
  spec.name = 'dry-plugins'
  spec.version = Dry::Plugins::VERSION
  spec.authors = ['Alex Semyonov']
  spec.email = ['alex@semyonov.us']

  spec.summary = 'Dry way to add plugins to your framework'
  spec.description = 'Generic plugin interface.'
  spec.homepage = 'http://alsemyonov.gitlab.com/dry-plugins/'
  spec.license = 'MIT'

  spec.files = `git ls-files -z`.split("\x0").reject do |f|
    f.match(%r{^(test|spec|features)/})
  end
  spec.bindir = 'exe'
  spec.executables = spec.files.grep(%r{^exe/}) { |f| File.basename(f) }
  spec.require_paths = ['lib']

  spec.add_runtime_dependency 'dry-configurable'
  spec.add_runtime_dependency 'dry-container', '~> 0.6.0'
  spec.add_runtime_dependency 'dry-auto_inject'
  spec.add_runtime_dependency 'dry-equalizer'
  spec.add_runtime_dependency 'dry-core'
  spec.add_runtime_dependency 'inflecto'

  spec.add_development_dependency 'development-toolbox', '~> 0.6'
  spec.add_development_dependency 'simplecov'
end
